discussion/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('todolist/', include('todolist.urls')),
    path('todolist/event/', include('todolist.urls'))
]

todolist/urls.py
# from django.contrib import admin
from django.urls import path
from . import views

app_name = 'todolist'
urlpatterns = [
    path('', views.index, name="index"),
    # localhost:8000/todolist/1
    path('<int:todoitem_id>/', views.todoitem, name="viewtodoitem"),
    path('event/<int:eventitem_id>', views.eventitem, name="vieweventitem"),
    # path('admin/', admin.site.urls),
    # path('todolist/', include('todolist.urls')),
    path('register/', views.register, name="register"),
    path('change-password/', views.change_password, name="change_password"),
    path('login/', views.login_view, name="login"),
    path('logout/', views.logout_view, name="logout"),
    path('add_task/', views.add_task, name="add_task"),
    path('add_event/', views.add_event, name="add_event"),
    path('event/<int:eventitem_id>/edit', views.update_event, name="update_event"),
    path('<int:todoitem_id>/edit', views.update_task, name="update_task"),
    path('<int:todoitem_id>/delete', views.delete_task, name="delete_task"),
    path('event/<int:eventitem_id>/delete', views.delete_event, name="delete_event")
]

todolist/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class ToDoItem(models.Model):
    # CharField = String value
    # max_length - > is a modifier
    task_name = models.CharField(max_length=50)    
    description = models.CharField(max_length=200)
    status = models.CharField(max_length=50, default="Pending")
    # DateTimeField = DateTime datatype
    date_created = models.DateTimeField("Date Created")
    # Adding a user_id to the ToDoItem table, which is a foreign key connected to the Users table.
    user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

class EventItem(models.Model):
    # CharField = String value
    # max_length - > is a modifier
    event_name = models.CharField(max_length=50)
    description = models.CharField(max_length=200)
    status = models.CharField(max_length=50, default="Pending")
    # DateTimeField = DateTime datatype
    date_created = models.DateTimeField("Date Created")
    # Adding a user_id to the ToDoItem table, which is a foreign key connected to the Users table.
    user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

todolist/forms.py
from django import forms

class LoginForm(forms.Form):
    username = forms.CharField(label="Username", max_length=20)
    password = forms.CharField(label="Password", max_length=20)

class AddTaskForm(forms.Form):
    task_name = forms.CharField(label="Task Name", max_length=50)
    description = forms.CharField(label="Description", max_length=200)

class UpdateTaskForm(forms.Form):
    task_name = forms.CharField(label="Task Name", max_length=50)
    description = forms.CharField(label="Description", max_length=200)
    status = forms.CharField(label="Status", max_length=50)
    
class AddEventForm(forms.Form):
    event_name = forms.CharField(label="Event Name", max_length=50)
    description = forms.CharField(label="Description", max_length=200)

class UpdateEventForm(forms.Form):
    event_name = forms.CharField(label="Task Name", max_length=50)
    description = forms.CharField(label="Description", max_length=200)
    status = forms.CharField(label="Status", max_length=50)

todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404

from django.http import HttpResponse

from django.template import loader

# We import the built-in 'User' model to be able to do operations to the built-in Users table from Django
from django.contrib.auth.models import User

from django.contrib.auth import authenticate, login, logout

from django.forms.models import model_to_dict

from .models import ToDoItem, EventItem

from .forms import LoginForm, AddTaskForm, UpdateTaskForm, AddEventForm, UpdateEventForm

from django.utils import timezone

def index(request):
    todoitem_list = ToDoItem.objects.filter(user_id = request.user.id)
    eventitem_list = EventItem.objects.filter(user_id=request.user.id)
    # output = ', '.join([todoitem.task_name for todoitem in todoitem_list])
    template = loader.get_template('todolist/index.html')
    context = {
        'todoitem_list': todoitem_list,
        'eventitem_list': eventitem_list,
        'user': request.user
    }

    return HttpResponse(template.render(context, request))
    #return render(request, "todolist/index.html", context)

def eventitem(request, eventitem_id):
    eventitem = get_object_or_404(EventItem, pk=eventitem_id)

    return render(request, "todolist/event/eventitem.html", model_to_dict(eventitem))

def todoitem(request, todoitem_id):
    todoitem = get_object_or_404(ToDoItem, pk=todoitem_id)

    return render(request, "todolist/todoitem.html", model_to_dict(todoitem))

    # 'model_to_dict' function translates a data model into a python dictionary (object). This is so that we can use the data as a regular object/dictionary.
    
    # todoitem_list = ToDoItem.objects.all()
    # 'model_to_dict' function translates a data model into a python dictionary (object). This is so that we can use the data as a regular object/dictionary.
    # todoitem = model_to_dict(ToDoItem.objects.get(pk=todoitem_id))
    # template = loader.get_template('todolist/todoitem.html')
    # response = "You are viewing the details of %s"
    
    # context = {
    #     'todoitem_list': todoitem_list,
    #     'user': request.user
    # }
    # return HttpResponse(template.render(context, request))

    # ACTIVITY
    # 1. Create a todoitem template
    # 2. In the template, show the 'task_name', 'description', 'status' of the todo item. (each enclosed in an HTML tag)
    # 3. At the end of the template, create an anchor tag that will return the user to the 'index' page

def register(request):
    users = User.objects.all()
    is_user_registered = False

    # Loops through each existing user and checks if they already exists in the table
    for individual_user in users:
        if individual_user.username == "johndoe":
            is_user_registered = True
            break
    
    # The context 'is_user_registered' is put after the for loop in order for it to get the updated value if 'for' Loop above equals to True
    context = {
        "is_user_registered": is_user_registered
    }

    if is_user_registered == False:
        # 1. Creating a new instance of the User model.
        user = User()

        # 2. Assign data values to each property of the model
        user.username = "johndoe"
        user.first_name = "John"
        user.last_name = "Doe"
        user.email = "john@mail.com"
        user.set_password("john1234")
        user.is_staff = False
        user.is_active = True

        # 3. Save the new instance of a user into the database.
        user.save()

        # The context will be the data to be passed to the template
        context = {
            "first_name": user.first_name,
            "last_name": user.last_name,
        }

    return render(request, "todolist/register.html", context)


def change_password(request):
    is_user_authenticated = False

    user = authenticate(username="johndoe", password="john1234")

    print(user)

    if user is not None:
        authenticated_user = User.objects.get(username="johndoe")
        # SELECT * FROM users WHERE username = "johndoe"

        authenticated_user.set_password("johndoe1")
        authenticated_user.save()

        is_user_authenticated = True

    context = {
        "is_user_authenticated": is_user_authenticated
    }

    return render(request, "todolist/change_password.html", context)



def login_view(request):
    context = {}

    if request.method == 'POST':
        # request.POST contains all the fields coming from the login.html form
        form = LoginForm(request.POST)
        print(form.is_valid())

        if form.is_valid() == False:
            # if you user LoginForm() without passing any data, it will just return the properties 'username' and 'password' without any data/value
            form = LoginForm()
            

        else:
            # we use the 'form.cleaned_data[]' to get the properties that we need from the form
            # we can use the properties declared in the form.py within the LoginForm class to get their values
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']

            print(username)
            print(password)

            user = authenticate(username=username, password=password)

            context = {
                "username": username,
                "password": password
            }

            if user is not None:
                login(request, user)
                return redirect("todolist:index")
            else:
                context = {
                    "error": True
                }
        
    return render(request, "todolist/login.html", context)



def logout_view(request):
    logout(request)
    return redirect("todolist:index")



def add_event(request):
    context = {}

    if request.method == 'POST':
        form = AddEventForm(request.POST)

        if form.is_valid() == False:
            form = AddEventForm()

        else:
            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']

            duplicates = EventItem.objects.filter(event_name=event_name)

            if not duplicates:
                EventItem.objects.create(
                    event_name=event_name,
                    description=description,
                    date_created=timezone.now(),
                    user_id=request.user.id  # ID of the currently logged in user
                )

                return redirect('todolist:index')

            else:
                context = {
                    "error": True
                }

    return render(request, "todolist/add_event.html", context)


def add_task(request):
    context = {}

    if request.method == 'POST':
        form = AddTaskForm(request.POST)

        if form.is_valid() == False:
            form = AddTaskForm()

        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']

            duplicates = ToDoItem.objects.filter(task_name=task_name)

            if not duplicates:
                ToDoItem.objects.create(
                    task_name = task_name,
                    description = description,
                    date_created = timezone.now(),
                    user_id = request.user.id # ID of the currently logged in user
                    )

                return redirect('todolist:index')
                    
            else:
                context = {
                    "error": True
                }
    
    return render(request, "todolist/add_task.html", context)


def update_event(request, eventitem_id):
    eventitem = EventItem.objects.filter(pk=eventitem_id)

    context = {
        "user": request.user,
        "eventitem_id": eventitem_id,
        # Accessing the first element is necessary because the "ToDoItem.objects.filter()" method returns a queryset
        "event_name": eventitem[0].event_name,
        "description": eventitem[0].description,
        "status": eventitem[0].status
    }

    if request.method == 'POST':
        form = UpdateEventForm(request.POST)

        if form.is_valid() == False:
            form = UpdateEventForm()
        else:
            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']
            status = form.cleaned_data['status']

        if eventitem:
            eventitem[0].event_name = event_name
            eventitem[0].description = description
            eventitem[0].status = status

            eventitem[0].save()

            return redirect("todolist:index")
        else:
            context = {
                "error": True
            }

    return render(request, "todolist/event/update_event.html", context)



def update_task(request, todoitem_id):
 # Returns a queryset
    todoitem = ToDoItem.objects.filter(pk=todoitem_id)

    context = {
        "user": request.user,
        "todoitem_id": todoitem_id,
        # Accessing the first element is necessary because the "ToDoItem.objects.filter()" method returns a queryset
        "task_name": todoitem[0].task_name,
        "description": todoitem[0].description,
        "status": todoitem[0].status
    }

    if request.method == 'POST':
        form = UpdateTaskForm(request.POST)

        if form.is_valid() == False:
            form = UpdateTaskForm()
        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']
            status = form.cleaned_data['status']

        if todoitem:
            todoitem[0].task_name = task_name
            todoitem[0].description = description
            todoitem[0].status = status

            todoitem[0].save()
            
            return redirect("todolist:index")
        else:
            context = {
                "error": True
            }

    return render(request, "todolist/update_task.html", context)



def delete_task(request, todoitem_id):

todolist/templates/todolist/event/eventitem.html
{% extends 'base.html' %}

{% block title %}
    Event Item
{% endblock %}

{% block content %}
<div class="text-center my-3">
    <h1>
        {{ event_name }}
    </h1>
    
    <h3>
        Description:
    </h3>
    
    <p>
        {{ description }}
    </p>
    
    <h3>
        Status:
    </h3>
    
    <p>
        {{ status }}
    </p>

    

    <button class="btn btn-primary mx-1 text-decoration-none">
        <a href="{% url 'todolist:update_event' id %}" class="text-light text-decoration-none">
            Update Event
        </a>
    </button>

    <button class="btn btn-primary mx-1 text-decoration-none">
        <a href="{% url 'todolist:delete_event' id %}" class="text-light text-decoration-none">
            Delete Event
        </a>
    </button>

    <button class="btn btn-warning mx-1 text-decoration-none">
        <a href="{% url 'todolist:index' %}" class="text-light text-decoration-none">
            Back to index page
        </a>
    </button>


</div>
{% endblock %}



<!-- {% if todoitem_list and user.is_anonymous == False %}
<h1>
    Welcome {{user.first_name}} {{user.last_name}}!
</h1>
<h3>
    Here are your todo lists:
</h3>
<ul>
    {% for todoitem in todoitem_list %} -->
<!-- <li><a href="/todoitem/{{ todoitem.id }}/">{{ todoitem.task_name }}</a></li>
    <li><a href="/todoitem/{{ todoitem.id }}/">{{ todoitem.description }}</a></li> -->
<!-- <li type="none">
        TASK NAME
    </li>

    <ul>
        <li type="circle">
            {{ todoitem.task_name }}
        </li>
    </ul>
    

    <li type="none">
        DESCRIPTION
    </li>
    
    <ul>
        <li type="circle">
            {{ todoitem.description }}
        </li>
    </ul>
    

    <li type="none">
        STATUS
    </li>
    

    <ul>
        <li type="circle">
            {{ todoitem.status }}
        </li>
    </ul>

    <a href="{% url 'todolist:index' %}">Back to index page</a>

    {% endfor %}
</ul>
{% elif todoitem_list.count == 0 and user %}
<p>No tasks have been created.</p>
{% else %}
<h1>
    You are not authorized to access this page.
</h1>
<p>
    Kindly login <a href="login">here</a>
</p>
{% endif %} -->

todolist/templates/todolist/event/update_event.html
{% extends 'base.html' %}

{% block title %}
    Update Event
{% endblock %}

{% block content %}
    {% if user.is_anonymous == False %}
        <div class="container">
            <div class="row">
                <div class="col-6 offset-3">
                        <h1 class="text-center my-3">
                            Update Event
                        </h1>
                    {% if error == True %}
                        <p class="text-danger">
                            Event not found
                        </p>
                    {% endif %}
                    <form action="{% url 'todolist:update_event' eventitem_id %}" method="post">
                        {% csrf_token %}

                        <div class="mb-3">
                            <label for="event_name">
                                Event Name: 
                            </label>
                            
                            <input 
                            class="form-control" 
                            id="event_name" 
                            type="text" 
                            name="event_name" 
                            value="{{ event_name }}"
                            maxlength="50" 
                            required>
                        </div>

                        <div class="mb-3">
                            <label for="description">
                                Description: 
                            </label>

                            <textarea 
                            class="form-control" 
                            name="description" 
                            required>
                            {{ description }}
                            </textarea>
                        </div>

                        <div class="mb-3">
                            <label for="status">
                                Status: 
                            </label>
                            
                            <input 
                            class="form-control" 
                            id="status" type="text" 
                            name="status" 
                            value="{{ status }}"
                            maxlength="50" 
                            required>
                        </div>

                        <div class="text-center">
                            <input class="btn btn-success" type="submit" value="Update Event">
                            <button class="btn btn-warning mx-1 text-decoration-none">
                                <a href="{% url 'todolist:index' %}" class="text-light text-decoration-none">
                                    Back to index page
                                </a>
                            </button>
                        </div>




                    </form>
                </div>
            </div>
        </div>
    {% else %}
        <h1 class="text-center my-3">You are not authorized to access this page.</h1>
        <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
    {% endif %}
{% endblock %}